#pragma once
#include <stdint-gcc.h>

// USART definitions
#define USART_BAUDRATE 9600
#define BAUD_PRESCALE (((F_CPU / (USART_BAUDRATE * 16UL))) - 1)
#define BUFFERSIZE 10	// Number of bytes to store

volatile uint8_t usartBuffer[BUFFERSIZE];	// FIFO stack
volatile uint8_t writeIndex, currentIndex;

union SerialFloat
{
	uint8_t bytes[4];
	float f;
};

union SerialSignedWord
{
	uint8_t bytes[2];
	int16_t word;
};

// Initialize USART Module
void USART0_init(void);
// Send a single byte over USART
void USART0_send_byte(uint8_t data);
// Gets the most recent element from the buffer
uint8_t popFromBuffer(void);
// Add a new element to the buffer
void bufferInsert(uint8_t data);
// Utility send functions
void USART0_send_word(uint8_t code, int16_t data);
void USART0_send_float(uint8_t code, float data);
